/*****************************************************************************/
/* EXT.REX lists the number of files per extension in the current directory. */
/* Valid options are:                                                        */
/* /W Wide list ... multiple extensions per line (default)                   */
/* /S Single extension per line                                              */
/* ?  display help                                                           */
/*****************************************************************************/

arg opt
if opt = '?' then do i = 1
   line = sourceline(i)
   if line = '' then
       exit
   if left(line, 3) \== '/* ' then
       iterate
   say substr(line, 3, 75)
   end
if opt \= '/W' & opt \= '/S' & opt \= '' then call error 'bad option - try ?'
'listfile (ftype sorta ext stem ext.'
if rc \= 0 then call error 'aborting, listfile rc =' rc

parse var ext.1 . last .
n = 0
do i = 1 to ext.0
   parse var ext.i . ext .
   if ext = last then n = n + 1
   else call output
   end
call output
say ''
exit

output:
   if last = '' then last = 'none'
   if opt = '/S' then say left(lower(last), 4, '.')right(n, 3, '.')
   else call charout ,left(lower(last), 4, '.')right(n, 3, '.')'   '
   n = 1
   last = ext
   return

error:
   say arg(1)
   exit 1
