/*********************************************************************/
/* Program to read from the keyboard and interpret REXX instructions */
/*********************************************************************/

If arg(1, 'e') then do
   interpret arg(1)
   exit
   end

Say 'REXX interpreter running...type EXIT to terminate'
Say

start:
Signal On error
Signal On syntax
Signal On failure
Signal On halt

Do Forever
    call charout ,"> "
    parse linein @_@
    interpret @_@
End

Error:
    Say 'REXX:- Application returned an errorlevel' rc
    signal start

Syntax:
    Say 'REXX:- Error' rc':' errortext(rc)
    signal start

Failure:
    If rc = -3 then
       Say 'REXX:- Program not found'
    Else if rc = -8 then
       Say 'REXX:- Insufficient memory for program'
    Else
       Say 'REXX:- Return code' rc
    Signal start

Halt:
    Say 'REXX:- CTRL-BREAK intercepted'
    Signal start
